'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'IIIIIII  DEMO ZUM BASIC-COMPUTER                (by DIE HARD)  IIIII
'IIIIIII  Erweitert durch Programmteile     (by Dietmar Harlos) IIIII
'IIIIIII  Angepasst an OC-Basic  fr Open-Micro   (by Eckhard)  IIIII
'IIIIIII  Sieben Segment Anzeige mit  SAA 1064                  IIIII
'IIIIIII  28.09.2005 11:55:42                                  IIIII
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

' Einer der vielen erhltlichen Bausteine mit IIC-Bus
' Interface ist der 4 DIGIT LED DISPLAY TREIBER SAA1064. Er ist der Baustein
' der die 4 DIGIT 7 SEGMENTANZEIGE der LED-Anzeige ansteuert.
' Er hat ein verhltnismssig einfaches Protokoll das auch in BASIC
' recht einfach in die Treibersoftware fr diesn Baustein umgesetzt werden kann.
'
' <START><ADDRESS><INSTRUCTION><CONTROL><DIGIT1><DIGIT2><DIGIT3>DIGIT<4><STOP>
'
' Die Adresse besteht aus einem festen, nicht vernderbaren Anteil und
' einem vom Benutzer whlbaren Teil (zwei Bits). Das letzte Bit
' legt fest ob eine READ (Eingabe) oder WRITE (Ausgabe) ber den SAA1064
' erfolgt
' In diesem Beispiel hat der SAA1064 die Adresse 3 (alle Bits auf HI),
' alle Jumper abgezogen.
' Allerdings ist beim diesem Baustein die interne Adressdecodierung
' etwas anders als blich. Das Modul hat deshalb 4 Jumper die dem
' Modul die Adresse 0 bis 3 zuweisen.
' Es darf jeweils nur ein Jumper gesteckt sein.
' J1   A0=0, A1=0     0 Volt  (bei 5 V)
' J2   A0=1, A1=0   1/3 Betriebsspannung
' J3   A0=0, A1=1   2/3
' J4   A0=1, A1=1     5 V
' Bemerkung: wenn man sich die Anzeige selbst baut, legt man die Adressleitung
' zweckmssigerweise auf 0 oder 5 V, einen Spannungsteiler braucht man nur bei
' drei oder vier Anzeigebausteinen.
'
' Damit ergibt sich fr eine READ-Operation folgender Wert:
'
' 0 1 1 1 0 x x 1       READ-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' Fr eine WRITE-Operation ist das letzte Bit LO und es ergibt sich
' folgender Wert:
'
' 0 1 1 1 0 x x 0       WRITE-Operation
' I------I-----I-I
' FIX ADR  ADR  R/W
'
' x sind die mit Jumper auf 0 setzbaren Adressbits.
' In diesem Beispiel wird angenommen, dass kein Jumper gesteckt ist. Die
' Adresse ist damit 118= $76 = 01110110

' Das INSTRUCTION-BYTE legt fest mit welches der internen Register
' zuerst beschriebnen wird. In unserem Beispiel ist das INSTRUCTION BYTE
' Null, das bedeutet dass nach dem INSTRUCTION BYTE das KONTROLLREGISTER
' und danach die DATENREGISTER der vier Digits beschrieben werden.
' Das KONTROLLREGISTER legt den LED Modus (hier Multiplex)und die LED
' Helligkeit fest.
'
' Die Zuweisung der Segmente zum jeweiligen Bit sind so:
'        a
'      f   b              xgfedcba (a=bit0)
'        g
'      e   c
'        d
'Werte der einzelnen Segmente in Dezimal
' a = 1
' b = 2
' c = 4
' d = 8
' e = 16
' f = 32
' g = 64
'dp = 128

' Beispiel:
' Eine 1 wird durch die Segmente bc dargestellt und die entsprechenden Bits sind
' log 1, die anderen 0 -> 00000110 =&H06, oder Dezimal b = 2, c = 4  2+4 = 6
' nehmen wir die < 8 >, alle Segmente sind an. 1+2+4+8+16+32+64 = 127 dezimal
' der Dezimalpunkt soll an sein, nochmals 128 dazurechnen.
' die < 8 > in binr &B01111111 mit dp &B11111111
' Um Ihnen die Arbeit mit dem Treiber zu vereinfachen
' brauchen Sie sich aber um diese Angelegenheiten nicht zu kmmern,
' da enstprechende Unterprogramme im Treiber vorhanden sind.
'-----------------------------------------------------------------------
' SCHNITTSTELLE ZUM TREIBER
' Ihre Schnittstelle zum LED Treiber ist die Variable BRIGHTNES der Sie
' die vordefinierten Werte BRIGHT0 bis BRIGHT7 zuweisen knnnen.
' BRIGHT0 ist vollstndiege Dunkelheit, die LEDs sind also aus.
' Der Aufruf des Unterprogramms GOSUB SHOW_COUNTER bringt den Inhalt
' der Wortvariablen zur Anzeige.
' Ausserdem sind einige Buchstaben definiert um kurze Meldungen wie
' z.B. "Err" anzeigen zu knnen.
'-----------------------------------------------------------------------
' INNERHALB DES TREIBERS
' Die Variablen DIGIT1 bis DIGIT4 sind der Inhalt der am LED Display
' dargestellt werden soll. Natrlich muss der Inhalt des DIGITS fr
' die LED Anzeige 7-Segment codiert sein. 
' Mit der Tabelle DECODER wird eine Ziffer in den entsprechenden 7-Segment-Code umgewandelt.
' Es ist ihnen berlassen, ob sie lieber mit einer dezimal,hex oder binr-Tabelle arbeiten.
' Nach der Berechning des Displayinhalts aus der Variablen COUNTER wird mit Aufruf des
' Unterprogramms GOSUB SENDBUF der komplette Datenrahmen zum Display bertragen.
'-----------------------------------------------------------------------
' Der IIC-Bus liegt an zwei beliebigen Ports, Z.B PORT [5](SCL) und PORT [6] (SDA)
'------------------------------------------------------------------------
' BEISPIEL
' Das Beispiel zeigt einen laufenden Zhler bis 255 und rdy nach Ablauf
' des Programms
'---------------------------------------------------------------------
' ACHTUNG:
' Das LED-Display bentigt bei max. Helligkeit sehr viel Strom
' Die Khlung des Spannungsreglers auf dem Application-Board ist
' dafr nicht ausreichend. Betreiben Sie das Display mit BRIGHT2,
' wenn keine zustzliche Khlung fr den Spannungsregler auf dem
' Application-Board vorgesehen ist.
'-----------------------------------------------------------------------
 option openmicro
'--------------------------
'------ I/O PORTS ---------
'--------------------------
'--- IIC INTERFACE  -------

define SCL port[5]
define SDA port[6]

'---- PROGRAMM ------------
'define LIGHT       port[16]  wird nicht bentigt
'--------------------------
'---- SYSTEM MEMORY -------
'--------------------------
define BRIGHTNES   byte[1]
define DIGIT1      byte[2]
define DIGIT2      byte[3]
define DIGIT3      byte[4]
define DIGIT4      byte[5]
'-------------------------
define IICDATA     byte[6]
define MASK        byte[7]
define zae        byte[8]   ' wird nicht bentigt
'- LCD DRIVER APP BOARD ---
define lcd_buf     byte[9]   ' wird nicht bentigt
define i         byte[10]
define COUNTER     byte[11]
define HUNDERTER   byte[12]
define ZEHNER      byte[13]
define EINER       byte[14]

'-------------------------
define LEDREAD    &B01110111  ' wird nicht bentigt
 define LEDWRITE    &B01110110
'----- LED HELLIGKEIT -----
'----- Control-Byte -------
'Note
'C0 = 0 static mode, i.e. continuous display of digits 1 and 2
'C0 = 1 dynamic mode, i.e. alternating display of digit 1 + 3 and 2 + 4
'C1 = 0/1 digits 1 + 3 are blanked/not blanked
'C2 = 0/1 digits 2 + 4 are blanked/not blanked
'C3 = 1 all segment outputs are switched-on for segment test
'C4 = 1 adds 3 mA to segment output current
'C5 = 1 adds 6 mA to segment output current
'C6 = 1 adds 12 mA to segment output current

'               C76543210
define BRIGHT0 &B00000111    '&H07     0 mA
define BRIGHT1 &B00010111    '&H17     3 mA
define BRIGHT2 &B00100111    '&H27     6 mA
define BRIGHT3 &B00110111    '&H37     9 mA
define BRIGHT4 &B01000111    '&H47    12 mA
define BRIGHT5 &B01010111    '&H57    15 mA
define BRIGHT6 &B01100111    '&H67    18 mA
define BRIGHT7 &B01110111    '&H77    21 mA
'-------------------------
define MINUS &H40
define A &H77
define B &H7F
define C &H39
define d &H5E
define E &H79
define F &H71
define G &H7D
define H &H76
define J &H0F
define L &H38
define n &H54
define o &H5C
define P &H73
define r &H50
define S &H6D
define t &H78
define U &H3E
define y &H6E


zae = 0

while not eof          ' Endlos-Schleife durchlaufen (eof darf aber nicht erreicht werden)
print Zae "    " minute ":" second
gosub i2c_init
 add zae,1              'zae um 1 erhhen = zae = zae +1
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
'III           DEMO LAUFENDER ZHLER                   II
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
BRIGHTNES=BRIGHT2                             'Helligkeit

'----------- TEST - ALL SEGMENTS ON --------------------
gosub SHOW_TEST:'pause 50
'----------- BLANK - ALL SEGMENTS OFF ------------------
gosub SHOW_BLANK:'pause 50
'----------- SHOW IN MESSAGE ----------------------------
gosub SHOW_OUT:'pause 50
'----------- SHOW CLEAR MESSAGE -------------------------
gosub SHOW_CLEAR:'pause 50
'----------- SHOW ERROR MESSAGE -------------------------
gosub SHOW_ERROR:'pause 50
'----------- SHOW ON MESSAGE ----------------------------
gosub SHOW_ON:'pause 50
'----------- SHOW OFF MESSAGE ---------------------------
gosub SHOW_OFF:'pause 50

'---------- SHOW RUNNING COUNTER ----------------------
for counter=0 to 255
  gosub show_counter
  'pause 2                 'Pause von 40 msec, damit man die Zahlen lesen kann.
next


dbnzctr=255              ' das gleiche rckwrts
#loop
   counter = dbnzctr
   gosub show_counter
dbnz loop

'---------  4 gleiche Digits ---------------------------
'Zm Testen einer Anzeigeeinheit
'-------------------------------------------------------
#probe
'pause 100
for counter = 0 to 9
  DIGIT1 = looktab (decoder, counter)
  Digit2 = Digit1
  Digit3 = Digit1
  Digit4 = Digit1
 gosub SENDBUF
 'pause 100
next counter

'--------- FLASHING READY -------------------------------
'Counter hat den Wert 10
'--------------------------------------------------------
repeat
 gosub SHOW_READY:'pause 30
  gosub SHOW_BLANK:'pause 30
 counter = counter -1
until counter <= 0
wend
end
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

'--------------------------------------------------------
'----    TREIBER LED-DISPLAY MIT IIC-BUS SAA1064
'--------------------------------------------------------
#SHOW_COUNTER
DIGIT4=0
hunderter=counter /100:DIGIT3 = looktab (decoder, hunderter)
zehner=(counter mod 100)/10:DIGIT2 = looktab (decoder, zehner)  'mod gibt den Restwert einer Division wieder.
einer=counter mod 10: DIGIT1 = looktab (decoder, einer)         'z.B 238 mod 100 = 38
goto SENDBUF                                                    'Rcksprung erfolgt ber SENDBUF(gefllt mir nicht)
 '-------------------------------------------------------
#SHOW_BLANK
DIGIT4=0:DIGIT3=0:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_IDLE
DIGIT4=I:DIGIT3=d:DIGIT2=L:DIGIT1=E:goto SENDBUF
#SHOW_IN
DIGIT4=I:DIGIT3=n:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_OUT
DIGIT4=O:DIGIT3=U:DIGIT2=t:DIGIT1=0:goto SENDBUF
#SHOW_CLEAR
DIGIT4=C:DIGIT3=L:DIGIT2=r:DIGIT1=0:goto SENDBUF
#SHOW_READY
DIGIT4=r:DIGIT3=D:DIGIT2=y:DIGIT1=0:goto SENDBUF
#SHOW_ERROR
DIGIT4=E:DIGIT3=r:DIGIT2=r:DIGIT1=0:goto SENDBUF
#SHOW_ON
DIGIT4=O:DIGIT3=n:DIGIT2=0:DIGIT1=0:goto SENDBUF
#SHOW_OFF
DIGIT4=o:DIGIT3=F:DIGIT2=F:DIGIT1=0:goto SENDBUF
#SHOW_TEST
DIGIT4=&HFF:DIGIT3=&HFF:DIGIT2=&HFF:DIGIT1=&HFF:goto SENDBUF

'-----------------------------------------------------
'HHHHHHHHHH      IIC-BUS DRIVER      HHHHHHHHHHHHHHHHH
'IIIIIIIIII  LED-DISPLAY IIC-BUS SAA1064
'------------------------------------------------------
'IIIIIIIIIII Sende-Routine in Basic
'Die Routine die verwendet werden soll in #SENDBUF benennen
'------------------------------------------------------
#SENDBUF
gosub I2C_START                      'Start
IICDATA=LEDWRITE:gosub I2C_send      'Adresse
IICDATA=0:gosub I2C_send             'INSTRUCTION
IICDATA=BRIGHTNES:gosub I2C_send     'CONTROL
IICDATA=DIGIT4:gosub I2C_send        'die
IICDATA=DIGIT3:gosub I2C_send        'einzelnen
IICDATA=DIGIT2:gosub I2C_send        'vier
IICDATA=DIGIT1:gosub I2C_send        'Digits
gosub I2C_stop                       'Stop
return
'------------------------------------------------------
'IIIIIIIIIII Sende-Routine in Maschinensprache
'------------------------------------------------------
#SENDBUFv
gosub I2C_START                      'Start
i2c_write(LEDWRITE)                  'Adresse
i2c_write(0)                        'INSTRUCTION
i2c_write(BRIGHTNES)                'CONTROL
i2c_write(DIGIT4)
i2c_write(DIGIT3)
i2c_write(DIGIT2)
i2c_write(DIGIT1)
gosub I2C_stop                       'Stop
return

'-------------------------------------------
#i2c_init              'SDA wird vom Pull-Up-Widerstand auf high (5 Volt)
  deact sda            'gezogen, sobald es deaktiviert wird. Falls SDA nach
  for i=0 to 8       'Deaktivierung aber immer noch low ist, dann wird es
    scl=on             'vom Slave auf Masse gezogen. Deshalb weitertakten,
    if sda then return 'bis der Slave mit seiner Uebertragung fertig ist
    tog scl 'off       'oder ein Highbit auf der SDA-Leitung uebertraegt.
  next i             'Denn nur wenn SDA high, also deaktiviert ist, laesst
return                 'sich ein Start-Signal ueber den I2C-Bus uebertragen.
'---------------------------------------------------------------------------
#i2c_start
  scl=on
  sda=off
  tog scl 'off
return
'-------------------------------------------------------------------------
#I2C_send
MASK=&B10000000
While MASK                  'Schleife so lange durchlaufen bis MASK 0 ist
 SDA =(IICDATA and MASK)    'IICData wird  maskiert, ein Bit wird gesendet
  SCL=on:SCL=off
 MASK=MASK shr 1            'schiebt Bits eine Stelle nach rechts aus &B10000000 wird &B01000000 usw.
wend
'---- 9th CLOCK FOR ACKNOWLEDGE ----------
'ACKN
deact SDA
SCL=on
SCL=off
SDA=off
return

TABLE i2c_write       'Modul in Maschinensprache, selbe Routine wie I2C_send
  &h1206
  &had29 &hae08 &h4824 &h041b &h0420 &h041b &h001a &h0418
  &h0021 &h0021 &h0021 &h0019 &h005a &h26e8 &h1b04 &h4f18
  &h0021 &h000a &h0001 &h4a19 &h005f &h83ae &h0183
TABEND



' --- I2C-Bus-Deaktivierung -------------------------------------------------

#i2c_stop
  sda=off
  deact scl 'on
  deact sda 'on
return



' ---------------------------------------------------------------------------

'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII
' Tabelle von 0 bis 9 in verschiedenen Zahlensystemen.
'IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII

 'Dezimal ZU 7 SEGMENT
   '0 1  2  3  4   5   6  7  8   9
 'Table Decoder byte
  ' 63,6,91,79,102,109,125,7,127,111
 'tabend

 'Hex ZU 7 SEGMENT
   '   0    1    2    3   4    5    6    7    8   9
 Table Decoder byte
   &H3F,&H06,&H5B,&H4F,&H66,&H6D,&H7D,&H07,&H7F,&H6F
 tabend

 'Binr ZU 7 SEGMENT
   '   0          1          2          3          4          5          6          7          8          9
 'Table Decoder byte
'  &B00111111,&B00000110,&B01011011,&B01001111,&B11100110,&B01101101,&B01111100,&B00000111,&B01111111,&B01100111
'  tabend